/********************************************************************
*                 Copyright (C) 2009 by MoSCoS                      *
*              http://www.physics.uq.edu.au/MoSCoS                  *
*               School of Physics and Mathematics                   *
*            The University of Queensland, Australia.               *
*  Authors: Fernando Alonso-Marroquin, Sergio-Andres Galindo-Torres *
********************************************************************/

#include <cstdlib>
#include <math.h>
#include <iostream>
#include <fstream>
#include "src/Graphs/Graph.h"
#define N 9
using namespace std;

int main ()
{
    srand(100000);
    int i,j,paso=1000,np=0;
    double t,dt=1.e-4,E,Erot,Ekin,Epot;
    Vec3 r,v,ome,I(1,0,0),J(0,1,0),K(0,0,1),Z(0,0,0),L,P;
    Quaternion q(1,0,0,0);
    CParticle aron[N];
    string s("tetra");
    CParticle wall1(6,2,10,0.1,Z,q);
    r=-5*K;
    //CParticle wall2(10,10,0.3,r,q);
    r=-(5-1.25)*K;
    //CParticle wall3(10,10,2.5,0.3,r,q);
    for (i=0;i<N;i++) {
        ome=Vec3((1.*rand())/RAND_MAX,(1.*rand())/RAND_MAX,(1.*rand())/RAND_MAX);
        q=normalize_rotation(2*M_PI*(1.*rand())/RAND_MAX,ome);
        ome=0.5*Vec3((1.*rand())/RAND_MAX,(1.*rand())/RAND_MAX,(1.*rand())/RAND_MAX);
        j=int(sqrt(9));
        r=1.6*(i%j-j/2)*I+1.6*((i/j)%j-j/2)*J+(5.+1.6*(i/9))*K;
        v=Vec3(0,0,0);
        aron[i]=CParticle(1.,1.,0.1,r,v,v,q,s);
        aron[i].start(dt);
    }
    
    CGraph gp("poli.pov");
    for (i=0;i<N;i++) {
       gp.Graph_Particle(aron[i],"Gray");
    }
    gp.Graph_Particle(wall1,"Blue");
    //gp.Graph_Particle(wall2,"Blue");
    //gp.Graph_Particle(wall3,"Blue");
    gp.close();
    
   
    return 0;
}
