#include<iostream>
#include<fstream>
#include<string>
#include<math.h>
#include<stdlib.h>
#include<algorithm>
#include<map>
#include<vector>
#include<string>
#include "../../src/Graphs/Graph.h"
#define N 288

extern Quaternion normalize_rotation(double,Vec3 &);

int main()
{
    srand(100000);
    int i,j,paso=1000;
    double t,dt=1.e-4,kn,kt,mu,aspect_ratio,pm,minv,maxv,volume,ra,l,Xmax=5.,Xmin=-5.,slope=0.*(M_PI/180);
    Vec3 r,v,ome,I(1,0,0),J(0,1,0),K(0,0,1),Z(0,0,0);
    string s("rice");
    ifstream infile("parameters.txt");
    ofstream BI("biaxial.txt"),FN,EN("energy.txt"),GM("granulometry.txt");
    infile >> kn; 	infile.ignore(200,'\n');
    infile >> kt; 	infile.ignore(200,'\n');
    infile >> mu;     infile.ignore(200,'\n');
    infile >> aspect_ratio;     infile.ignore(200,'\n');
    infile >> pm;     infile.ignore(200,'\n');
    infile >> dt;  infile.ignore(200,'\n');
    infile >> minv;     infile.ignore(200,'\n');
    infile >> maxv;     infile.ignore(200,'\n');
    paso=int(0.1/dt);
    Quaternion q(1,0,0,0);
    CParticle aron[N];
    CParticle wall[4];
    r=-3*K;
    wall[0]=CParticle(20,10,0.1,r,q);
    r=(1.6*(N/9))*K;
    wall[3]=CParticle(20,10,0.1,r,q);
    r=2.5*J;
    q=normalize_rotation(M_PI/2,I);
    wall[1]=CParticle(20,10,0.1,r,q);
    r=-2.5*J;
    wall[2]=CParticle(20,10,0.1,r,q);
    map<pair<int,int>,CInteracton> Inaron;
    map<pair<int,int>,CInteracton> Inawall;
    map<pair<int,int>,CInteracton>::iterator it;
    vector<int> CPI,CPD;
    vector<int>::iterator itv;
    for (i=0;i<N-1;i++) {
          for(j=i+1;j<N;j++) {
            pair<int,int> indexes     = make_pair(i,j);
            CInteracton   interaction = CInteracton(aron[i],aron[j]);
            Inaron.insert(make_pair(indexes,interaction));
        }
    }
    for(i=0;i<N;i++) {
        for(j=0;j<4;j++) {
            pair<int,int> indexes     = make_pair(i,j);
            CInteracton   interaction = CInteracton(aron[i],wall[j]);
            Inawall.insert(make_pair(indexes,interaction));
        }
    }
    for(j=0;j<4;j++) {
        wall[j].start(dt);
    }
    for (i=0;i<N;i++) {
	volume=(maxv-minv)*(1.*rand())/RAND_MAX+minv;
        ra=pow(volume/(2*M_PI*(-(1./3.)+(1./aspect_ratio))),1./3.);
        l=2*(-ra+ra/aspect_ratio);
        ome=Vec3((1.*rand())/RAND_MAX,(1.*rand())/RAND_MAX,(1.*rand())/RAND_MAX);
        q=normalize_rotation(2*M_PI*(1.*rand())/RAND_MAX,ome);
        ome=0.5*Vec3((1.*rand())/RAND_MAX,(1.*rand())/RAND_MAX,(1.*rand())/RAND_MAX);
        j=int(sqrt(9));
        r=1.6*(i%j-j/2)*I+1.6*((i/j)%j-j/2)*J+(-2+1.6*(i/9))*K;
        v=Vec3(0,0,0);
        aron[i]=CParticle(l,1.,ra,r,v,v,q,s);//length_edge, mass, sphero-radius, position, velocity, ang_velocity, quaternion, particleType
        aron[i].start(dt);
        GM <<i<<" "<<volume<<endl;
    }
    GM.close();
    for(it=Inaron.begin();it!=Inaron.end();it++) {
         (*it).second.setmu(mu);
	     (*it).second.setkn(kn);
	     (*it).second.setkt(kt);
    }
    for(it=Inawall.begin();it!=Inawall.end();it++) {
         (*it).second.setmu(mu);
	     (*it).second.setkn(kn);
	     (*it).second.setkt(kt);
    }
     for(i=0;i<N;i++) {
        for(j=1;j<3;j++) {
            pair<int,int> indexes     = make_pair(i,j);
            Inawall[indexes].setmu(0.0);
        }
        j=3;
        pair<int,int> indexes     = make_pair(i,j);
        Inawall[indexes].setmu(1.);
        j=0;
        indexes     = make_pair(i,j);
        Inawall[indexes].setmu(1.);
    }
    
    
    
    //recuerde 2.02
    wall[3].setm(30.);
    for(t=0,j=0;t<=20;t+=dt,j++) {
        //cout << t << " " << aron[7].getXmax() << " " << aron[7].getXmin() << " " <<aron[7].getr().X()<<endl;
        r=(-9.8*cos(slope))*K+(9.8*sin(slope))*I;
        wall[3].startforce(wall[3].getm()*r);
        if (fabs(t-6)<dt/2) {
            v=wall[3].getr();
            ome=5*I;
            q=Quaternion(1,0,0,0);
            wall[3]=CParticle(20,10,0.1,v,q,ome);
            wall[3].start(dt);
            ome=-5*I;
            wall[0].setv(ome);
        }
        for(i=0;i<N;i++) {
            //cout << t << " " << i<<" "<<aron[i].getXmax() << " " << aron[i].getXmin() << " " <<aron[i].getr()<<endl;
            aron[i].startforce(aron[i].getm()*r);
            if (aron[i].getXmax()>Xmax) {
                if (((find(CPD.begin(),CPD.end(),i))==(CPD.end()))) {
                    itv=CPD.end();
                    CPD.insert(itv,i);
                }
                if (aron[i].getXmin()>Xmax) {
                    itv=find(CPD.begin(),CPD.end(),i);
                    CPD.erase(itv);
                    v=(Xmin-Xmax)*I;
                    //cout << v << endl;
                    aron[i].moveBy(v);
                    //cout << t << " " << aron[0].getXmax() << " " << aron[0].getXmin() << " " <<aron[0].getr().X()<<endl;
                }
            }
            if (aron[i].getXmin()<Xmin) {
                if (((find(CPI.begin(),CPI.end(),i))==(CPI.end()))) {
                    itv=CPI.end();
                    CPI.insert(itv,i);
                }
                if (aron[i].getXmax()<Xmin) {
                    itv=find(CPI.begin(),CPI.end(),i);
                    CPI.erase(itv);
                    v=(Xmax-Xmin)*I;
                    aron[i].moveBy(v);
                    //cout << t << " " << aron[0].getXmax() << " " << aron[0].getXmin() << " " <<aron[0].getr().X()<<endl;
                }
            }
            
        }
        //cout << t << " " << 1<<" "<<aron[1].getF()<<endl;
        for(it=Inawall.begin();it!=Inawall.end();it++) {
            (*it).second.calcForce(dt);
        }
        for(it=Inaron.begin();it!=Inaron.end();it++) {
            (*it).second.calcForce(dt);
        }
        //cout << t << " " << 1<<" "<<aron[1].getF()<<endl;
        for (itv=CPD.begin();itv!=CPD.end();itv++) {
            v=(Xmin-Xmax)*I;
            aron[(*itv)].moveBy(v);
            //cout << t << " " <<(*itv)<< " " << aron[0].getXmax() << " " << aron[0].getXmin() << " " <<aron[0].getr().X()<<endl;
            //cout << t << " " <<(*itv)<< " " << aron[(*itv)].getF()<<endl;
            for (i=0;i<(*itv);i++) {
                pair<int,int> indexes = make_pair(i,(*itv));
                if (((find(CPD.begin(),CPD.end(),i))==(CPD.end()))) {
                    Inaron[indexes].calcForce(dt);
                }
            }
            for (i=(*itv)+1;i<N;i++) { 
                pair<int,int> indexes = make_pair((*itv),i);
                if (((find(CPD.begin(),CPD.end(),i))==(CPD.end()))) {
                    Inaron[indexes].calcForce(dt);
                }
            }
            v=(Xmax-Xmin)*I;
            aron[(*itv)].moveBy(v);
            //cout << t << " " << aron[0].getXmax() << " " << aron[0].getXmin() << " " <<aron[0].getr().X()<<endl;
        }
        r=wall[3].getF().Z()*K;
        wall[3].startforce(r);
        if (t<6) 
        {
           wall[3].updatePosition(dt);
           wall[3].updateVertices();
        }
        
        for (itv=CPI.begin();itv!=CPI.end();itv++) {
            v=(Xmax-Xmin)*I;
            aron[(*itv)].moveBy(v);
            for (i=0;i<(*itv);i++) {
                pair<int,int> indexes = make_pair(i,(*itv));
                if (((find(CPI.begin(),CPI.end(),i))==(CPI.end()))) {
                    Inaron[indexes].calcForce(dt);
                }
            }
            for (i=(*itv)+1;i<N;i++) {
                pair<int,int> indexes = make_pair((*itv),i);
                if (((find(CPI.begin(),CPI.end(),i))==(CPI.end()))) {
                    Inaron[indexes].calcForce(dt);
                }
            }
            v=(Xmin-Xmax)*I;
            aron[(*itv)].moveBy(v);
            //cout << t << " " << aron[0].getXmax() << " " << aron[0].getXmin() << " " <<aron[0].getr().X()<<endl;
        }
        //cout << t << " " << 1<<" "<<aron[1].getF()<<endl;
        //cout << t << " " << aron[0].getXmax() << " " << aron[0].getXmin() << " " <<aron[0].getr().X()<<endl;
        if (j%paso==0) {
            CGraph gp("poli.pov");
            r=17*J+3*K+10*K;
            //r=17*(cos(0.1*M_PI*(t+4))*I+sin(0.1*M_PI*(t+4))*J)+(10-0.2*t)*K;
            //!set aim of the camera
	    Vec3 F=Z; 
	    gp.Set_Camera(r,F);
            for(i=0;i<N;i++) {
                gp.Graph_Particle(aron[i],"Gray");
            }
            for(i=0;i<4;i++) {
                gp.Graph_Particle(wall[i],"Blue");
            }
            gp.close();
            gp.Animation(j/paso);
        }
        
        
        
        for(i=0;i<N;i++) {
            aron[i].updatePosition(dt);
            aron[i].updateOrientation(dt);
            aron[i].updateVertices();
        }
        //cout << t << " " << aron[0].getXmax() << " " << aron[0].getXmin() << " " <<aron[0].getr().X()<<endl;
        //cout << t <<" "<<CPD.size()<<endl;
    }
    /*
    for (itv=CPD.begin();itv!=CPD.end();itv++) {
        cout << (*itv) << endl;
    }
    cout << (*find(CPD.begin(),CPD.end(),0)) <<" "<<(*CPD.end())<< " " <<((find(CPD.begin(),CPD.end(),0))==(CPD.end()))<<endl;
    */
    
}
