#ifndef __QUATERNION_H
#define __QUATERNION_H

#include "vec3.h"

class Quaternion {
    protected:
        double q0;
        Vec3 q;
    public:
        Quaternion() {};
        Quaternion(double a,Vec3 v) {q0=a; q=v;};
        Quaternion(double a,double b, double c,double d) {q0=a; q.set_x(b); q.set_y(c); q.set_z(d);};
        double norm(void);
        void normalize(void);
        friend Quaternion normalize_rotation(double,Vec3 &);
        Quaternion conj(void);
        Quaternion operator *(Quaternion Q);
        Quaternion operator +(Quaternion Q);
        Quaternion operator -(Quaternion Q);
        friend Vec3 rotate(Quaternion & Q,Vec3 & V);
        Quaternion operator *(double temp);
        Vec3 getvector(void) {return q;};
        double getscalar(void) {return q0;};
        void show_on_screen(void) {cout <<q0<<" "; q.show_on_screen(); cout <<endl;};
};



#endif
