#ifndef __INTERACTON_H
#define __INTERACTON_H

#include "Particle.h"

class CInteracton {
    protected:
        //! pointers to the particles 
        CParticle *m_P1,*m_P2;
        //!normal stiffness, tangential stiffness, potential energy, dissipated 
        //!energy, normal viscocity, tangential viscosity, friction coefficient
        double m_kn,m_kt,m_Epot,m_Edis,m_gn,m_gt,m_mu;
        //!edge-edge, vertex-face and face-vertex contact
        map<pair<int,int>,Vec3> m_free,m_frvf,m_frfv;
        //! normal force
        Vec3 m_fn;
        //! returns true when the contact is active
        bool m_c;
    public:
        //! default constructor
        CInteracton (void) {};
        //! constructor of interacton from the pointers of the  particles
        CInteracton(CParticle &p1,CParticle &p2);
        //! calculate force
        void calcForce(double);
        //! get potential energy
        double getEpot(void) {return m_Epot;};
        //! get normal force 
        Vec3 getFn(void) {return m_fn;};
        //! returns true when the contact is active
        bool getContact(void) {return m_c;};
        //! get friction coefficient 
        double getmu(void) {return m_mu;};
        //! set the friction coefficient 
        void setmu(double mu) {m_mu=mu;};
        //! set the normal stiffness
	void setkn(double k) {m_kn=k;};
        //! set the tangential stiffness
	void setkt(double k) {m_kt=k;};
        friend class CGraph;
};



#endif
